#include<bits/stdc++.h>
using namespace std;
//bool bg;
struct data{
	int l,r,tot;
	bool vis;
}st[386];
int n,m,k,a[2000086],book[1086],nxt[2000086];
//bool ed;
void innt(){
	memset(book,0,sizeof(book));
	for(int i=1;i<=n;i++){
		st[i].l=1;
		st[i].r=m;
		st[i].tot=0;
		st[i].vis=false;
	}
}
void wk2(){
	int op=0;
	for(int i=1;i<=m;i++){
		if(i==nxt[i]){
			for(int j=1;j<=n;j++){
				if(st[j].vis==false){
//					printf("1 %d\n2 %d %d",j,book[a[i]],j);
					op+=2;
				}
			}
			continue;
		}
		for(int j=1;j<=n;j++){
			int xx;
			if(st[j].vis==false){
				st[j].vis=true;
				book[a[i]]=j;
//				printf("1 %d\n",j);
				op++;
				break;
			}
			for(int l=j-1;l>=1;l--){
				if(book[a[l]]==j){
					xx=l;
					break;
				}
			}
			if(nxt[xx]<nxt[i]){
				book[a[i]]=j;
//				printf("1 %d\n",j);
				op++;
				break;
			}
		}
	}
	printf("%d\n",op);
	for(int i=1;i<=m;i++){
		if(i==nxt[i]){
			for(int j=1;j<=n;j++){
				if(st[j].vis==false){
					printf("1 %d\n2 %d %d",j,book[a[i]],j);
//					op+=2;
				}
			}
			continue;
		}
		for(int j=1;j<=n;j++){
			int xx;
			if(st[j].vis==false){
				st[j].vis=true;
				book[a[i]]=j;
				printf("1 %d\n",j);
//				op++;
				break;
			}
			for(int l=j-1;l>=1;l--){
				if(book[a[l]]==j){
					xx=l;
					break;
				}
			}
			if(nxt[xx]<nxt[i]){
				book[a[i]]=j;
				printf("1 %d\n",j);
//				op++;
				break;
			}
		}
	}
}
void work(){
	bool flag=false;
	scanf("%d%d%d",&n,&m,&k);
	for(int i=1;i<=m;i++){
		scanf("%d",&a[i]);
		if(!book[a[i]]){
			book[a[i]]=i;
		}
		else{
			nxt[i]=nxt[book[a[i]]]=i;
			book[a[i]]=i;
		}
	}
	//bg
	innt();
	for(int i=1;i<=m;i++){
		flag=false;
		if(i==nxt[i]){
			st[book[a[i]]].tot--;
			flag=true;
			if(!st[book[a[i]]].tot){
				st[book[a[i]]].vis=false;
				st[book[a[i]]].l=1;
				st[book[a[i]]].r=m;
			}
			continue;
		}
		for(int j=1;j<=n;j++){
			if(!st[j].vis){
				st[j].vis=true;
				st[j].l=a[i];
				st[j].r=nxt[i];
				st[j].tot=1;
				book[a[i]]=j;
				flag=true;
				break;
			}
			else if(st[j].l<a[i]&&nxt[i]<st[j].r){
				st[j].l=a[i];
				st[j].r=nxt[i];
				st[j].tot++;
				book[a[i]]=j;
				flag=true;
				break;
			}
		}
		if(flag==false){
			wk2();
			return;
		}
	}
	//ed
	printf("%d\n",m);
	innt();
	for(int i=1;i<=m;i++){
		flag=false;
		if(i==nxt[i]){
			st[book[a[i]]].tot--;
			printf("1 %d\n",book[a[i]]);
			flag=true;
			if(!st[book[a[i]]].tot){
				st[book[a[i]]].vis=false;
				st[book[a[i]]].l=1;
				st[book[a[i]]].r=m;
			}
			continue;
		}
		for(int j=1;j<=n;j++){
			if(!st[j].vis){
				st[j].vis=true;
				st[j].l=a[i];
				st[j].r=nxt[i];
				st[j].tot=1;
				book[a[i]]=j;
				printf("1 %d\n",j);
				flag=true;
				break;
			}
			else if(st[j].l<a[i]&&nxt[i]<st[j].r){
				st[j].l=a[i];
				st[j].r=nxt[i];
				st[j].tot++;
				book[a[i]]=j;
				printf("1 %d\n",j);
				flag=true;
				break;
			}
		}
	}
}
int main(){
	freopen("meow.in","r",stdin);
	freopen("meow.out","w",stdout);
//	printf("%lld\n",&ed-&bg>>20);
	int T;
	scanf("%d",&T);
	while(T--){
		work();
	}
	return 0;
}